gtkmm: Gtk::Buildable Class Reference

gtkmm 3.24.3

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Buildable Class Reference

A base class for objects that can be built by Gtk::Builder. More...

`#include <gtkmm/buildable.h>`

Inheritance diagram for Gtk::Buildable:
[legend]

## Public Member Functions
| Buildable (Buildable&& src) noexcept
Buildable& | operator= (Buildable&& src) noexcept
| ~Buildable () noexcept override
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A base class for objects that can be built by Gtk::Builder.

Buildable allows objects to extend and customize thier deserialization from Gtk::Builder UI descriptions. The interface includes methods for setting names and properties of objects, parsing custom tags and constructing child objects.

All gtkmm widgets, and many non-widget objects, derive from this base class. The main user of this interface is Gtk::Builder. There should be very little need for applications to call any of Buildable's methods.

Since gtkmm 3.0:

## Constructor & Destructor Documentation

## ◆ Buildable() [1/2]

Gtk::Buildable::Buildable | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Buildable() [2/2]

Gtk::Buildable::Buildable | ( | Buildable&& | src | ) |
| noexcept

## ◆ ~Buildable()

Gtk::Buildable::~Buildable | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::Buildable::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_name()

Glib::ustring Gtk::Buildable::get_name | ( |  | ) | const

Gets the name of the buildable object.

Gtk::Builder sets the name based on the [GtkBuilder UI definition][BUILDER-UI] used to construct the buildable.

Since gtkmm 2.12:

Returns
  The name set with set_name().

## ◆ get_type()

static GType Gtk::Buildable::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkBuildable* Gtk::Buildable::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkBuildable* Gtk::Buildable::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

Buildable& Gtk::Buildable::operator= | ( | Buildable&& | src | ) |
| noexcept

## ◆ set_name()

void Gtk::Buildable::set_name | ( | const Glib::ustring & | name | ) |

Sets the name of the buildable object.

Since gtkmm 2.12:

Parameters

  name | Name to set.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Buildable > wrap | ( | GtkBuildable * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.